package {
    import simple3D.*;
    import flash.display.*;
    import flash.geom.Point;

    [SWF(   backgroundColor = "#FFFFFF", 
            frameRate       = "60"     , 
            width           = "1024"   , 
            height          = "768"   )]

    public class Main extends Sprite {

        public function Main () {
           init(); 
        }

        private function init():void{

            var square_xy:Array = new Array();
            var square_xz:Array = new Array();
            var square_yz:Array = new Array();

            // creating and storing the 3D-points for a xy-square
            square_xy.push( new SpacePoint( 0,   0,   0 ) );
            square_xy.push( new SpacePoint( 0,   200, 0 ) );
            square_xy.push( new SpacePoint( 200, 200, 0 ) );
            square_xy.push( new SpacePoint( 200, 0,   0 ) );

            // creating and storing the 3D-points for a xz-square
            square_xz.push( new SpacePoint( 0,   0,   0 ) );
            square_xz.push( new SpacePoint( 0,   0, 200 ) );
            square_xz.push( new SpacePoint( 200, 0, 200 ) );
            square_xz.push( new SpacePoint( 200, 0,   0 ) );

            // creating and storing the 3D-points for a yz-square
            square_yz.push( new SpacePoint( 0,   0,   0 ) );
            square_yz.push( new SpacePoint( 0,   0, 200 ) );
            square_yz.push( new SpacePoint( 0, 200, 200 ) );
            square_yz.push( new SpacePoint( 0, 200,   0 ) );

            // actually drawing the square-outlines in different colours
            connect_points( square_xy, 0xFF0000 );
            connect_points( square_xz, 0x00FF00 );
            connect_points( square_yz, 0x0000FF );
        }

        private function connect_points( points:Array,
                                         colour:Number ):void {

            var last_point:Point = points[ points.length - 1 ].project();
            var start_x:Number = last_point.x;
            var start_y:Number = last_point.y;

            graphics.moveTo( start_x, start_y );
            graphics.lineStyle( 1, colour );

            // actually drawing lines between the dots
            for each ( var p3D:SpacePoint in points ) {
                 var point_2D:Point =  p3D.project();
                 graphics.lineTo( point_2D.x, point_2D.y );
            }
        }
    }
}
