package simple3D {
    import flash.geom.Point;

    public class SpacePoint {
        public static const ORIGIN_X:int = 370;
        public static const ORIGIN_Y:int = 450;

        public static const X_INFLUENCE_BY_Z:Number = .6;
        public static const X_INFLUENCE_BY_X:Number = .8;
        public static const Y_INFLUENCE_BY_Z:Number = .5;
        public static const Y_INFLUENCE_BY_X:Number = .4;

        public var x:Number;
        public var y:Number;
        public var z:Number;

        public function SpacePoint (param_x:Number, 
                                    param_y:Number, 
                                    param_z:Number) {
            x = param_x ;
            y = param_y ;
            z = param_z ;
        }

        public function project():Point {

            var x2D:Number =     ORIGIN_X 
                           + x * X_INFLUENCE_BY_X 
                           + z * X_INFLUENCE_BY_Z ;

            var y2D:Number =     ORIGIN_Y 
                           - y 
                           - x * Y_INFLUENCE_BY_X
                           + z * Y_INFLUENCE_BY_Z ;

            return new Point( x2D, y2D );
        }
    }
}
